<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProductionTimetableDeliveryStructure StructType
 * Meta informations extracted from the WSDL
 * - documentation: Delivery for Production Timetable Service type.
 * @subpackage Structs
 */
class ProductionTimetableDeliveryStructure extends AbstractServiceDeliveryStructure
{
    /**
     * The DatedTimetableVersionFrame
     * @var \StructType\DatedTimetableVersionFrameStructure
     */
    public $DatedTimetableVersionFrame;
    /**
     * The Extensions
     * @var \StructType\ExtensionsStructure
     */
    public $Extensions;
    /**
     * The version
     * Meta informations extracted from the WSDL
     * - default: 2.0
     * - documentation: Version number of response. fixed. | A string indicating the versioin of a SIRI data structure.
     * @var string
     */
    public $version;
    /**
     * Constructor method for ProductionTimetableDeliveryStructure
     * @uses ProductionTimetableDeliveryStructure::setDatedTimetableVersionFrame()
     * @uses ProductionTimetableDeliveryStructure::setExtensions()
     * @uses ProductionTimetableDeliveryStructure::setVersion()
     * @param \StructType\DatedTimetableVersionFrameStructure $datedTimetableVersionFrame
     * @param \StructType\ExtensionsStructure $extensions
     * @param string $version
     */
    public function __construct(\StructType\DatedTimetableVersionFrameStructure $datedTimetableVersionFrame = null, \StructType\ExtensionsStructure $extensions = null, $version = '2.0')
    {
        $this
            ->setDatedTimetableVersionFrame($datedTimetableVersionFrame)
            ->setExtensions($extensions)
            ->setVersion($version);
    }
    /**
     * Get DatedTimetableVersionFrame value
     * @return \StructType\DatedTimetableVersionFrameStructure|null
     */
    public function getDatedTimetableVersionFrame()
    {
        return $this->DatedTimetableVersionFrame;
    }
    /**
     * Set DatedTimetableVersionFrame value
     * @param \StructType\DatedTimetableVersionFrameStructure $datedTimetableVersionFrame
     * @return \StructType\ProductionTimetableDeliveryStructure
     */
    public function setDatedTimetableVersionFrame(\StructType\DatedTimetableVersionFrameStructure $datedTimetableVersionFrame = null)
    {
        $this->DatedTimetableVersionFrame = $datedTimetableVersionFrame;
        return $this;
    }
    /**
     * Get Extensions value
     * @return \StructType\ExtensionsStructure|null
     */
    public function getExtensions()
    {
        return $this->Extensions;
    }
    /**
     * Set Extensions value
     * @param \StructType\ExtensionsStructure $extensions
     * @return \StructType\ProductionTimetableDeliveryStructure
     */
    public function setExtensions(\StructType\ExtensionsStructure $extensions = null)
    {
        $this->Extensions = $extensions;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\ProductionTimetableDeliveryStructure
     */
    public function setVersion($version = '2.0')
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProductionTimetableDeliveryStructure
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
